



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java排序算法(四)：Shell排序</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java排序算法(四)：Shell排序</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-28 19:27:47 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p><strong>[基本的想法]</strong></p>
<p>将原本有大量记录数的记录进行分组。切割成若干个子序列，此时每一个子序列待排序的记录个数就比較少了，然后在这些子序列内分别进行直接插入排序，当整个序列都基本有序时。再对全体记录进行一次直接插入排序。</p>
<p>所谓的基本有序，就是小的keyword基本在前面，大的基本在后面，不大不小的基本在中间。像{2, 1, 3, 6, 4, 7, 5, 8, 9}这样能够称为基本有序了。</p>
<p><strong>[java实现]</strong></p>
<pre class="prettyprint linenums">public class ShellSort {

	public static void main(String[] args) {<br />
		int[] arr = { 6, 5, 3, 1, 8, 7, 2, 4 };<br />
		System.out.println(&quot;排序之前：&quot;);<br />
		for (int i = 0; i &lt; arr.length; i++) {<br />
			System.out.print(arr[i] + &quot; &quot;);<br />
		}

		// 希尔排序<br />
		shellSort(arr);

		System.out.println();<br />
		System.out.println(&quot;排序之后：&quot;);<br />
		for (int i = 0; i &lt; arr.length; i++) {<br />
			System.out.print(arr[i] + &quot; &quot;);<br />
		}<br />
	}

	/**<br />
	 * 希尔排序<br />
	 */<br />
	private static void shellSort(int[] arr) {<br />
		int j;<br />
		for (int gap = arr.length / 2; gap &gt; 0; gap = gap / 2) {<br />
			for (int i = gap; i &lt; arr.length; i++) {<br />
				int tmp = arr[i];<br />
				for (j = i; j &gt;= gap &amp;&amp; tmp &lt; arr[j - gap]; j = j - gap) {<br />
					arr[j] = arr[j - gap];<br />
				}<br />
				arr[j] = tmp;<br />
			}<br />
		}<br />
	}

}</pre>
<p><strong>[算法说明]</strong></p>
<p>希尔排序时间复杂度：O(nlogn)</p>
<p>Shell排序是不是一个稳定的排序算法。</p>
<div>
<p>版权声明：本文博客原创文章。博客，未经同意，不得转载。</p></p></div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9pm63y9.html">拉风的服务器监控工具，随时掌握服务器动态，AgileEAS&period;NET SOA 平台服务器监控工具集介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/495zoxm9.html">C&num;Light 和 uLua的对比第二弹</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7v4v1q.html">JavaScript 页面模板引擎</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ep4dm9.html">JavaWEB入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zm5159.html">夺命雷公狗---Thinkphp----4之数据表的设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd66o78.html">&lpar;转&rpar;数据库SQL优化大总结之 百万级数据库优化方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yw5jr8.html">FormData可实现异步传输二进制文件&lpar;即异步文件上传&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpojgjq.html">Manual &vert; BSD手册&vert; Linux手册 &vert; 数据库手册 &vert; 编程开发手册 &vert; WEB开发手册 &vert; 软件应用手册 &vert; 网络技术手册 &vert; GNU手册</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv10kz1q.html">koahub&period;js 0&period;09 发布，新增钩子机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gew06l8.html">Java 获取指定日期范围内的每个月，每季度，每一年</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge20408.html">Promise原理讲解 &amp;amp&semi;&amp;amp&semi; 实现一个Promise对象 &lpar;遵循Promise&sol;A&plus;规范&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj67638.html">ssl证书专题&lpar;3&rpar;&colon;创建CA和申请证书</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2eg06q.html">mysql5&period;7高版本加载低版本sql文件，时间不能为0000-00-00格式错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jn545q.html">logstash配置白名单决定去哪个index</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rkzz39.html">Spring Boot读取配置的 5 种方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j6pv0q.html">Vxlan学习笔记&mdash;&mdash;原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv61g38.html">BZOJ NOIP提高组十连测第一场</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpmz7z9.html">Linux笔记之如何分割文件或管道流：split</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp3l249.html">ifame&lowbar;自适应高度</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlxjw39.html">Spark（十七）图计算GraphX</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q7zxk5e9.html">MinGW开发工具的安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jdo4o8.html">Java中StringBuilder的清空方法比較</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljeykk9.html">利用内容提供者插入sms&lpar;装B程序&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jd7xx8.html">Core 中文文档</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp10e79.html">Java的LockSupport&period;park&lpar;&rpar;实现分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdjjd49.html">微信jssdk已无力吐槽</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pookj8.html">C&num;超级有用的一种类型&mdash;匿名类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kzk2z9.html">QDockWidget嵌套布局详解-实现Visual Studio布局</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdjw3z9.html">perl 继承概述</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojk1oeq.html">基于visual Studio2013解决C语言竞赛题之1061最大值和次最大值</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
